/*
 *  ==========================================================================
 *  DemoLoopRaceTrack.java: Compute distance around a running track.
 *
 *  Note: This program uses the old style of formatting for output. Can now
 *  use System.out.printf() instead.
 *
 *  Written By : Mark Austin                                      October 2005
 *  ==========================================================================
 */

package basics;

import java.lang.Math;
import java.util.*;
import java.io.*;
import java.text.*;

public class DemoLoopRaceTrack {

    public static void main( String args[] ) {
        double dRunningDistance;

        // Print header ...

        System.out.println(" X(m) | Distance (m)");
        System.out.println("--------------------");

        for ( double dX = 0.0; dX <= 1.0; dX = dX + 0.2 ) {

              // Compute running distance

              dRunningDistance = 400.0 + 2*Math.PI*dX;

              // Format "X" to one decimal place of accuracy ...

              DecimalFormat formatX = new DecimalFormat( "0.0" );
              String output1 = formatX.format( dX );

              // Format "Running Distance " to two decimal places of accuracy ...

              DecimalFormat formatR = new DecimalFormat( "00.00" );
              String output2 = formatX.format( dRunningDistance );

              // Print output ....

              System.out.println( output1 + " m       " + output2 + " m" );
        }

        System.out.println("--------------------");
    }
}
