/**
  *  =========================================================
  *  Node2D.java: Java class for nodes in a simple polygon.
  *             The class node extends class vector.
  * 
  *  Written by: Mark Austin                       April, 2019 
  *  =========================================================
  */

package geometry;

public class Node2D extends Vector2D {
   private String name;

   // -------------------------------------------------------
   // Constructor methods ....
   // -------------------------------------------------------

   public Node2D() {
      super( 0.0, 0.0 );
   }

   public Node2D( double dX, double dY ) {
      super( dX, dY );
   }

   public Node2D( String name, double dX, double dY ) {
      super( dX, dY );
      this.name = name;
   }

   // -------------------------------------------------------
   // Set name for the node ...
   // -------------------------------------------------------

   public void setName( String name ) {
      this.name = name;
   }

   // -------------------------------------------------------
   // Convert node to a string ...
   // -------------------------------------------------------

   public String toString() {
      return "Node2D(\"" + name + "\") is at (" + dX + "," + dY + ")";
   }

   // -------------------------------------------------------
   // Exercise methods in Node2D class .....
   // -------------------------------------------------------

   public static void main( String args[] ) {

      // Create and print "point 1", a node at coordinate (1,2)...

      Node2D nA = new Node2D();
      nA.dX = 1.0;
      nA.dY = 2.0;
      nA.setName("Point 1");

      System.out.println( nA.toString() );

      // Create and print "point 2", a node at coordinate (5,2)...

      Node2D nB = new Node2D ("Point 2", 5.0, 5.0 );
      System.out.println( nB );
      System.out.println( "Vector Magnitude =" + nB.length() );
   }
}

