/* 
 *  ====================================================================
 *  DemoScanner02.java: Use scanner to read in various data types from
 *  a file, then generate output: 
 *  
 *    String: Testing
 *    String: Scanner
 *    int: 10
 *    double: 12.2
 *    String: one
 *    boolean: true
 *    String: two
 *    boolean: false
 *                                                           April, 2019
 *  ====================================================================
 */ 

package io;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class DemoScanner02 {
  public static void main(String args[]) throws IOException {
     int      i;
     double   d;
     boolean  b;
     String str;

     // Write string to "DemoScanner02.txt" output file ...

     FileWriter fout = new FileWriter("DemoScanner02.txt");
     fout.write("Testing Scanner 10 12.2 one true two false");
     fout.close();

     // Create reader for "test.txt" ...

     FileReader fin = new FileReader("data/Test.txt");

     // Create scanner to read on file input stream ... 

     Scanner src = new Scanner(fin);

     // Process input ...

     while (src.hasNext()) {
        if (src.hasNextInt()) {
           i = src.nextInt();
           System.out.println("int: " + i);
        } else if (src.hasNextDouble()) {
           d = src.nextDouble();
           System.out.println("double: " + d);
        } else if (src.hasNextBoolean()) {
           b = src.nextBoolean();
           System.out.println("boolean: " + b);
        } else {
           str = src.next();
           System.out.println("String: " + str);
        }
    }

    fin.close();
  }
}

