/* 
 *  ========================================================================
 *  DemoSensorScanner03.java: Use scanner to read in lines from sensor data.
 *  
 *                                                            September 2020
 *  ========================================================================
 */ 

package io;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;
import java.util.ArrayList;

public class DemoSensorScanner04 {
  public static void main(String args[]) throws IOException {
     int      i;
     double   d;
     boolean  b;
     String str;
     String delimiters = "\\s+|,\\s*|\\.\\s*";

     // Write string to "DemoSensorScanner04.txt" output file ...

     FileWriter fout = new FileWriter("DemoSensorScanner04.txt");
     fout.write("Testing Sensor Scanner ... ");
     fout.close();

     // Create reader for "bluetooth data" ...

     String bluetoothFile = "00D0694B703B-20200123-064238-bt.txt";

     FileReader fin = new FileReader("data/sensor/" + bluetoothFile );

     // Create scanner to read on file input stream ... 

     Scanner src = new Scanner(fin);

     // Process header line ...

     String header   = src.nextLine();
     String[] tokens = header.split( delimiters ); 

     // Build arraylist of cell lines ...

     ArrayList bluetoothData = new ArrayList();
     for (int k = 1; k < tokens.length; k = k + 1) {
         bluetoothData.add( tokens[k] );
     }

     // Print details of bluetooth data ...

     System.out.printf("Bluetooth data ...\n");
     System.out.printf("=========================================== ...\n");
     for (int k = 1; k <= bluetoothData.size(); k = k + 1) {
         System.out.printf("--- Column %2d: id --> %s ...\n", k, (String) bluetoothData.get(k-1) ); 
     }
     System.out.printf("=========================================== ...\n");

     // Iterate over lines...
 
     i = 1;
     while (src.hasNextLine()) {

        // Create scanner for next line of input ...

        Scanner line = new Scanner( src.nextLine() );

        // Process individual tokens in line input ...

        int      itemNo = line.nextInt();
        String  address = line.next();
        double strength = line.nextDouble();
        int        date = line.nextInt();
        int          id = line.nextInt();

        // Process tokens within line ...

        System.out.printf("\n"); 
        System.out.printf("Bluetooth Reading %2d: %s ...\n", i, itemNo ); 
        System.out.printf("-----------------------------------------------\n");

        System.out.printf("---  address: %s ...\n", address );
        System.out.printf("--- strength: %5.2f ...\n", strength );
        System.out.printf("---     date: %8d ...\n", date );
        System.out.printf("---       id: %8d ...\n", id );

        System.out.printf("-----------------------------------------------\n");
        i = i + 1;
     }

     // Close input file ...

     fin.close();
  }

  public static boolean isNumeric(String strNum) {
     return strNum.matches("-?\\d+(\\.\\d+)?");
  }
}

