/*
 * ===========================================================================
 * TestFunction01.java: Demonstrate apply() method ... 
 * ===========================================================================
 */

package lambda;

import java.util.function.Function;
import java.util.function.DoubleFunction;

public class TestFunction01 {
   public static void main(String[] args) {

      Function<Integer,String> converter = (i)-> Integer.toString(i);

      System.out.printf("--- Part 1: Demonstrate Function apply() ...\n");
   
      System.out.println( converter.apply(3).length() );
      System.out.println( converter.apply(30).length() );
      System.out.println( converter.apply(300000).length() );

      System.out.printf("--- Part 2: Demonstrate DoubleFunction apply() ...\n");

      DoubleFunction<String> df = (d) -> d + " is now a string! ...";

      System.out.println( df.apply(0.5) );

      System.out.printf("--- Part 3: Demonstrate body function ...\n");

      Function<String,String> func1 = y -> {
         for(int i = 0; i < 10; i++) {
             System.out.println(i);
             if(i == 4){ break; }
         }
         return y + " from UMD ..." ;
      };

      System.out.println(func1.apply( "--- Hello" ));

      System.out.printf("--- Part 4: Use break statement in the lambda expression in order to jump out to a for loop ...\n");

      for(int i=0;i<10;i++){
         System.out.printf("i = %2d ...\n", i );
         if(i == 4) {
            Function<String,String> func2 = y -> { return y + " from UMD ..."; };
            System.out.println( func2.apply("--- Hola") );
         }
      }
    
  }
}
