/*
 *  ==================================================================
 *  Circle(): Implementation of the Circle class where data and circle
 *            properties can only be accessed through an interface.
 *
 *  Written by: Mark Austin                             February, 2019
 *  ==================================================================
 */

package objects;

import java.lang.Math.*;

public class Circle {
    protected double dX, dY, dRadius;

    // Constructor 

    public Circle () {}

    public Circle( double dX, double dY, double dRadius ) {
        this.dX = dX;
        this.dY = dY;
        this.dRadius = dRadius;
    }

    // Compute the circle area ....

    private double Area() {
       return Math.PI*dRadius*dRadius;
    }

    // Create public interface for variables and area computation....

    public void setX (double dX) {
        this.dX = dX;
    }

    public double getX () {
        return dX;
    }

    public void setY (double dY) {
        this.dY = dY;
    }

    public double getY () {
        return dY;
    }

    public void setRadius (double dRadius ) {
        this.dRadius = dRadius;
    }

    public double getRadius () {
        return dRadius;
    }

    public double getArea() {
        return Area();
    }


    // Copy circle parameters to a string format ...

    public String toString() {
       return "(x,y) = (" + dX + "," + dY + "): Radius = " + dRadius;
    }

    // ------------------------------------------------------
    // Exercise methods in class Circle ...
    // ------------------------------------------------------

    public static void main( String [] args ) {

       System.out.println("Exercise methods in class Circle");
       System.out.println("================================");

       Circle cA = new Circle();
       cA.setX(1.0);
       cA.setY(2.0);
       cA.setRadius(3.0);

       Circle cB = new Circle( 1.0, 2.0, 2.0 );

       System.out.printf("Circle cA : %s\n", cA.toString() );
       System.out.printf("Circle cA : Area = %5.2f\n", cA.getArea() );

       System.out.printf("Circle cB : %s\n", cB );
       System.out.printf("Circle cB : Area = %5.2f\n", cB.getArea() );
    }
}
