/* 
 * =========================================================================
 * RegularExpressions01.java: 
 * =========================================================================
 */ 

package regex;

import java.util.regex.Pattern;
import java.util.regex.Matcher;

public class RegularExpressions01 {
   public static void main ( String [] args ) {

      // Check phone number 

      System.out.printf("Example 01: Pattern for 7-digit phone number ...\n");

      String pattern01 = "\\d\\d\\d([,\\s])?\\d\\d\\d\\d";
      System.out.printf("Pattern: %s ...\n", pattern01 );

      String s = "1233323322";
      boolean result = s.matches(pattern01);
      System.out.printf("String Match: \"%s\" --> %s ...\n", s, Boolean.toString(result) );
      
      s = "1233323";
      result = s.matches(pattern01);
      System.out.printf("String Match: \"%s\" --> %s ...\n", s, Boolean.toString(result) );

      s = "123 3323";
      result = s.matches(pattern01);
      System.out.printf("String Match: \"%s\" --> %s ...\n", s, Boolean.toString(result) );

      // Find duplicate words in text ...

      System.out.printf("Example 02: Find duplicate words in text ...\n");

      String pattern02 = "(?i)\\b([a-z]+)\\b(?:\\s+\\1\\b)+";
      System.out.printf("Pattern: %s ...\n", pattern02 );

      Pattern r02 = Pattern.compile( pattern02, Pattern.CASE_INSENSITIVE);

      String  s02 = "The quick brown fox jumps";
      Matcher m02 = r02.matcher(s02);

      System.out.printf("Dulicate Words: \"%s\" --> %s ...\n", s02, Boolean.toString( m02.find() ) );

      s02 = "The quick brown brown fox jumps";
      m02 = r02.matcher(s02);

      System.out.printf("Dulicate Words: \"%s\" --> %s ...\n", s02, Boolean.toString( m02.find() ) );

      // Match integers and decimals in a string ...

      System.out.printf("Example 03: Match well-formed integers and decimals in a string ... \n");
      String pattern03 = "(\\d+(?:\\.\\d*)?|\\.\\d+)\\s+(\\S+)";
      System.out.printf("Pattern: %s ...\n", pattern03 );

      Pattern r03 = Pattern.compile( pattern03, Pattern.CASE_INSENSITIVE);

      String  s03 = "The quick brown fox jumps";
      Matcher m03 = r03.matcher(s03);
      System.out.printf("Contains number: \"%s\" --> %s ...\n", s03, Boolean.toString( m03.find() ) );

      s03 = "Wind speed is 34.0 mph";
      m03 = r03.matcher(s03);
      System.out.printf("Contains number: \"%s\" --> %s ...\n", s03, Boolean.toString( m03.find() ) );

      s03 = "Small negative integer -14 ...";
      m03 = r03.matcher(s03);
      System.out.printf("Contains number: \"%s\" --> %s ...\n", s03, Boolean.toString( m03.find() ) );

      s03 = "Small positive integer +14 ...";
      m03 = r03.matcher(s03);
      System.out.printf("Contains number: \"%s\" --> %s ...\n", s03, Boolean.toString( m03.find() ) );

      s03 = "Multiple numbers: -1.4 3.4 -26 34 ...";
      m03 = r03.matcher(s03);
      System.out.printf("Contains number: \"%s\" --> %s ...\n", s03, Boolean.toString( m03.find() ) );

      s03 = "Not number at all -1.4.3.4 ...";
      m03 = r03.matcher(s03);
      System.out.printf("Contains number: \"%s\" --> %s ...\n", s03, Boolean.toString( m03.find() ) );

      // Match floating point numbers with exponents ...

      System.out.printf("Example 04: Match floating point numbers with exponents ... \n");
      String pattern04 = "[-+]?[0-9]*\\.?[0-9]+([eE][-+]?[0-9]+)?";
      System.out.printf("Pattern: %s ...\n", pattern04 );

      Pattern r04 = Pattern.compile( pattern04, Pattern.CASE_INSENSITIVE);

      String  s04 = "Wind speed is 3.4e+01 mph";
      Matcher m04 = r04.matcher(s04);
      System.out.printf("Contains float: \"%s\" --> %s ...\n", s04, Boolean.toString( m04.find() ) );

   }
}
