/*
 *  =================================================================
 *  DemoDateFormatInput.java: Demo formatting for reading dates from
 *  character strings.
 *  =================================================================
 */

package time;

import java.io.IOException;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;
import java.text.ParseException;
import java.text.SimpleDateFormat;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

public class DemoDateFormatInput {
   public static void main(String[] args) {

        System.out.printf("Enter DemoDateFormatInput.main() ... \n" );
        System.out.printf("=================================================================== \n" );

        // Part 1. Convert string to java.util.Date ...

        SimpleDateFormat formatter = new SimpleDateFormat("dd-MMM-yyyy", Locale.ENGLISH);
        String inputString = "17-Nov-2021";
        try {
            Date date = formatter.parse( inputString );
            System.out.printf("--- Part 1: Input string: %s, Date: %s ...\n", inputString, date.toString());
        } catch (ParseException e) {
            System.out.printf("--- ERROR: Parse of text \"%s\" failed ...\n", inputString );
        }

        // Part 2. Convert string to java.util.Date ...

        formatter = new SimpleDateFormat("MMM dd yyyy", Locale.ENGLISH);
        inputString = "Nov 17 2021";
        try {
            Date date = formatter.parse( inputString );
            System.out.printf("--- Part 2: Input string: %s, Date: %s ...\n", inputString, date.toString());
        } catch (ParseException e) {
            System.out.printf("--- ERROR: Parse of text \"%s\" failed ...\n", inputString );
        }

        // Part 3. Convert date from US format to NZ format ...

        System.out.printf("--- Part 3: Convert date from US format to NZ format ...\n");

        DateTimeFormatter formatUSA = DateTimeFormatter.ofPattern("MMM-dd-yyyy");
        DateTimeFormatter formatNZ  = DateTimeFormatter.ofPattern("dd-MMM-yyyy");

        /* ... fix me ...

        inputString = "Nov 17 2021";
        try {
            LocalDateTime date = formatUSA.parse( inputString );
            System.out.printf("---    date (US format): %s ...\n", date.toString());
            System.out.printf("---    date (NZ format): %s ...\n", date.format(formatNZ).toString());
        } catch (ParseException e) {
        }

        ... */

        System.out.printf("=================================================================== \n" );
        System.out.printf("Finished !! \n" );
    }
}
